package com.seeyon.apps.ocip.exchange.edoc;

import java.io.PrintWriter;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;


import org.springframework.web.servlet.ModelAndView;

import com.seeyon.apps.govdoc.manager.GovdocExchangeManager;
import com.seeyon.apps.govdoc.po.GovdocExchangeDetail;
import com.seeyon.apps.ocip.util.CommonUtil;
import com.seeyon.ctp.common.authenticate.domain.User;
import com.seeyon.ctp.common.authenticate.domain.UserHelper;
import com.seeyon.ctp.common.controller.BaseController;
import com.seeyon.ctp.organization.bo.V3xOrgMember;
import com.seeyon.ctp.organization.manager.OrgManager;
import com.seeyon.ctp.privilege.manager.PrivilegeMenuManager;
import com.seeyon.ctp.util.Base64;
import com.seeyon.ctp.util.annotation.NeedlessCheckLogin;
import com.seeyon.ctp.util.json.JSONUtil;
@NeedlessCheckLogin
public class OCIPEdocController extends BaseController{
	
	private OrgManager orgManager;
	private PrivilegeMenuManager privilegeMenuManager;
	private GovdocExchangeManager govdocExchangeManager;
	
	public void setGovdocExchangeManager(GovdocExchangeManager govdocExchangeManager) {
		this.govdocExchangeManager = govdocExchangeManager;
	}

	public void setOrgManager(OrgManager orgManager) {
		this.orgManager = orgManager;
	}

	public void setPrivilegeMenuManager(PrivilegeMenuManager privilegeMenuManager) {
		this.privilegeMenuManager = privilegeMenuManager;
	}

	public ModelAndView index(HttpServletRequest request,HttpServletResponse response){
		String linkUrl = "";
		try{
			String ticket = request.getParameter("ticket");
			String ocipView = request.getParameter("ocipView");
			byte[] decodeBase64 = Base64.decodeBase64(ticket.getBytes());
			String string = new String(decodeBase64,"UTF-8");
			EdocLoginSSO userBean = JSONUtil.parseJSONString(string, EdocLoginSSO.class);
			Long detailId = userBean.getDetailId();
			Long summaryId = userBean.getSummaryId();
			String exchHasPluginSecret = userBean.getHasPluginSecret();
			V3xOrgMember member = orgManager.getMemberById(Long.valueOf(userBean.getTicket()));
			if (null != detailId) {
				GovdocExchangeDetail detail = govdocExchangeManager.getExchangeDetailById(detailId);
				linkUrl = "/govdoc/govdoc.do?method=summary&ocipCas=1&openFrom=exchangeRelation&summaryId=" + detail.getSummaryId() + "&exchasPluginSecret=" + exchHasPluginSecret+"&ocipView="+ocipView;
			}
			if (null != summaryId) {
				linkUrl = "/govdoc/govdoc.do?method=summary&ocipCas=1&openFrom=exchangeRelation&summaryId=" + summaryId + "&exchasPluginSecret=" + exchHasPluginSecret+"&ocipView="+ocipView;
			}
			if (member != null) {
				User user = new User();
				user.setId(member.getId());
				user.setLoginAccount(member.getOrgAccountId());
				user.setAccountId(member.getOrgAccountId());
				user.setDepartmentId(member.getOrgDepartmentId());
				user.setName(member.getName());
				user.setAuditAdmin(true);
				user.setLoginName(member.getId().toString());
				//标记为外系统单点登录来的请求
				user.setUserSSOFrom("other");
				CommonUtil.setCurrentUser(user);
				UserHelper.setResourceJsonStr(JSONUtil.toJSONString(privilegeMenuManager.getResourceCode(member.getId(),member.getOrgAccountId())));
			} else {
				response.setContentType("text/html;charset=UTF-8");
				PrintWriter out = response.getWriter();
				out.write("获取人员信息失败");
				out.close();
				return null;
			}
			
		}catch(Exception e){
			logger.error(e);
		}
		ModelAndView modelAndView = new ModelAndView("redirect:"+linkUrl);
		return modelAndView;
	}
}
