package com.seeyon.apps.ocip.exchange.edoc;

import java.util.HashMap;
import java.util.List;
import java.util.Map;

import com.seeyon.ctp.common.authenticate.domain.User;
import com.seeyon.ocip.common.IConstant;
import com.seeyon.ocip.configuration.OcipConfiguration;
import com.seeyon.ocip.exchange.ExchangeManager;
import com.seeyon.ocip.exchange.api.IBussinessService;
import com.seeyon.ocip.exchange.model.BIZContentType;
import com.seeyon.ocip.exchange.model.BIZExchangeData;
import com.seeyon.ocip.exchange.model.edoc.EdocOperation;

/**
 * @author Administrator
 * 
 */
public class OCIPExchangeEdocManager implements IOCIPExchangeEdocManager {

	private static final String SERVICE_NAME = IConstant.ExchangeType.edoc.name();
	private IBussinessService getBussinessService() {
		return OcipConfiguration.getInstance().getExchangeSpi().getBussinessService();
	}
//	public void sendEdoc(GovdocExchangeMain govdocExchangeMain, List<GovdocExchangeDetail> govdocExchangeDetails, User user) throws Exception {
//		exchangeManager.sendExchange(SERVICE_NAME, IConstant.ExchangeSubType.send.name(), govdocExchangeMain, govdocExchangeDetails, user);
//	}
	@Override
	public void sendEdoc(BIZExchangeData biz, User user) throws Exception {
		Map<String,Object> param = new HashMap<String,Object>();
		param.put("bizData", biz);
		param.put("user", user);
		getBussinessService().fireExchange(BIZContentType.OFC, param);
	}
	public void receiveEdoc(long mainId, long detailId, String comment) throws Exception {
		Map<String,Object> param = new HashMap<String,Object>();
		param.put("mainId", mainId);
		param.put("detailId", detailId);
		param.put("comment", comment);
		param.put("edocOperation",  EdocOperation.ACCEPTED);
		getBussinessService().fireExchange(BIZContentType.RET, param);
	}

	public void stepbackEdoc(long mainId, long detailId, String comment) throws Exception {
		Map<String,Object> param = new HashMap<String,Object>();
		param.put("mainId", mainId);
		param.put("detailId", detailId);
		param.put("comment", comment);
		param.put("edocOperation",  EdocOperation.STEPBACK);
		getBussinessService().fireExchange(BIZContentType.RET, param);
	}

	@Override
	public void cancelEdoc(String detailId, String repealComment) throws Exception {
		Map<String,Object> param = new HashMap<String,Object>();
		param.put("detailId", Long.parseLong(detailId));
		param.put("comment", repealComment);
		param.put("edocOperation", EdocOperation.REVOKED);
		getBussinessService().fireExchange(BIZContentType.RET, param);
	}

	@Override
	public void receiptEdoc(long mainId, long detailId,String ocipSendStatus) throws Exception {
		Map<String,Object> param = new HashMap<String,Object>();
		param.put("mainId", mainId);
		param.put("detailId", detailId);
		param.put("ocipSendStatus", ocipSendStatus);
		param.put("edocOperation",  EdocOperation.RECEIVED);
		getBussinessService().fireExchange(BIZContentType.RET, param);
	}
	@Override
	public void press(long mainId, long detailId,String content) throws Exception {
		Map<String,Object> param = new HashMap<String,Object>();
		param.put("mainId", mainId);
		param.put("detailId", detailId);
		param.put("comment", content);
		param.put("edocOperation",  EdocOperation.HASTEN);
		getBussinessService().fireExchange(BIZContentType.RET, param);
	}
	
	@Override
	public void signedAndStepback(long detailId, String comment) throws Exception {
		Map<String,Object> param = new HashMap<String,Object>();
		param.put("detailId", detailId);
		param.put("comment", comment);
		param.put("edocOperation", EdocOperation.SIGNEDANDSTEPBACK);
		getBussinessService().fireExchange(BIZContentType.RET, param);
	}
}
