package com.seeyon.apps.ocip.exchange.edoc;

import com.seeyon.apps.govdoc.helper.GovdocHelper;
import com.seeyon.apps.govdoc.manager.GovdocOCIPExchangeManager;
import com.seeyon.apps.govdoc.manager.GovdocSummaryManager;
import com.seeyon.ctp.common.content.affair.AffairData;
import com.seeyon.ctp.common.exceptions.BusinessException;
import com.seeyon.ocip.exchange.model.col.ColOperation;
import com.seeyon.v3x.edoc.domain.EdocSummary;
import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.springframework.transaction.support.TransactionSynchronizationAdapter;

/**
 * Created by Seeyon on 2019-6-3.
 */
public class OcipTransactionSynchronizationAdapter extends TransactionSynchronizationAdapter implements Runnable {

    private static final Log log = LogFactory.getLog(OcipTransactionSynchronizationAdapter.class);
    private AffairData cloneAData;
    private EdocSummary cloneSummary;
    private GovdocSummaryManager govdocSummaryManager;
    private GovdocOCIPExchangeManager govdocOCIPExchangeManager;
    private ColOperation colOperation;
    public OcipTransactionSynchronizationAdapter(ColOperation colOperation,EdocSummary cloneSummary,AffairData cloneAData,GovdocSummaryManager govdocSummaryManager,GovdocOCIPExchangeManager govdocOCIPExchangeManager)
    {
        this.cloneSummary = cloneSummary;
        this.cloneAData = cloneAData;
        this.govdocSummaryManager = govdocSummaryManager;
        this.govdocOCIPExchangeManager = govdocOCIPExchangeManager;
        this.colOperation = colOperation;

    }

    @Override
    public void afterCommit() {
        EdocSummary summary = null;
        try {
            summary = govdocSummaryManager.getSummaryById(cloneSummary.getId());
            GovdocHelper.updateCurrentNodesInfo(summary, false);
            cloneSummary.setCurrentNodesInfo(summary.getCurrentNodesInfo());
            new Thread(this).start();
        } catch (Exception e) {
            log.error(e);
        }
    }

    @Override
    public void run() {
        try {

            this.govdocOCIPExchangeManager.handCollaborationAffair(cloneAData, colOperation, cloneSummary);
        } catch (Exception e) {
            log.error(e);
        }
    }
}
